/**********************************************************************
SQL Saturday #62 (January 15th, 2010. Tampa, FL)

Dmitri Korotkevitch: "Refactoring for performance"

Saving data
**********************************************************************/


use SqlSat62
go

if exists(
	select * 
	from sys.tables t join sys.schemas s on t.schema_id = s.schema_id
	where s.name = 'dbo' and t.name = 'DataRecords'
)
	drop table dbo.DataRecords
go

create table dbo.DataRecords
(
	ID int not null,
	Field1 varchar(20) not null,
	Field2 varchar(20) not null,	
	Field3 varchar(20) not null,	
	Field4 varchar(20) not null,	
	Field5 varchar(20) not null,
	Field6 varchar(20) not null,	
	Field7 varchar(20) not null,	
	Field8 varchar(20) not null,	
	Field9 varchar(20) not null,
	Field10 varchar(20) not null,	
	Field11 varchar(20) not null,	
	Field12 varchar(20) not null,	
	Field13 varchar(20) not null,
	Field14 varchar(20) not null,	
	Field15 varchar(20) not null,	
	Field16 varchar(20) not null,	
	Field17 varchar(20) not null,
	Field18 varchar(20) not null,	
	Field19 varchar(20) not null,	
	Field20 varchar(20) not null,
	
	constraint PK_DataRecords
	primary key clustered(ID)
)
go



































if exists(
	select * 
	from sys.procedures p join sys.schemas s on p.schema_id = s.schema_id
	where s.name = 'dbo' and p.name = 'InsertDataRecordsTVP'
)
	drop proc dbo.InsertDataRecordsTVP
go


if exists(
	select * 
	from sys.types t join sys.schemas s on t.schema_id = s.schema_id
	where s.name = 'dbo' and t.name = 'DataRecordsTVP'
)
	drop type dbo.DataRecordsTVP
go


create type dbo.DataRecordsTVP as Table
(
	ID int not null,
	Field1 varchar(20) not null,
	Field2 varchar(20) not null,	
	Field3 varchar(20) not null,	
	Field4 varchar(20) not null,	
	Field5 varchar(20) not null,
	Field6 varchar(20) not null,	
	Field7 varchar(20) not null,	
	Field8 varchar(20) not null,	
	Field9 varchar(20) not null,
	Field10 varchar(20) not null,	
	Field11 varchar(20) not null,	
	Field12 varchar(20) not null,	
	Field13 varchar(20) not null,
	Field14 varchar(20) not null,	
	Field15 varchar(20) not null,	
	Field16 varchar(20) not null,	
	Field17 varchar(20) not null,
	Field18 varchar(20) not null,	
	Field19 varchar(20) not null,	
	Field20 varchar(20) not null,
	
	primary key(ID)
)	
go	

create proc dbo.InsertDataRecordsTVP
(
	@Data dbo.DataRecordsTVP READONLY
)
as
begin
	set xact_abort on
	set transaction isolation level read committed
	set nocount on
	
	begin tran
		insert into dbo.DataRecords(ID,Field1,Field2,Field3,Field4,Field5,
			Field6,Field7,Field8,Field9,Field10,Field11,Field12,Field13,
			Field14,Field15,Field16,Field17,Field18,Field19,Field20)
			select ID,Field1,Field2,Field3,Field4,Field5,
				Field6,Field7,Field8,Field9,Field10,Field11,Field12,Field13,
				Field14,Field15,Field16,Field17,Field18,Field19,Field20
			from @Data
	commit
end
go


































if exists(
	select * 
	from sys.procedures p join sys.schemas s on p.schema_id = s.schema_id
	where s.name = 'dbo' and p.name = 'InsertDataRecordsElementsXml'
)
	drop proc dbo.InsertDataRecordsElementsXml
go

create proc dbo.InsertDataRecordsElementsXml
(
	@Data xml
)
as
begin
	set xact_abort on
	set transaction isolation level read committed
	set nocount on
	
	begin tran
		insert into dbo.DataRecords(ID,Field1,Field2,Field3,Field4,Field5,
			Field6,Field7,Field8,Field9,Field10,Field11,Field12,Field13,
			Field14,Field15,Field16,Field17,Field18,Field19,Field20)
		SELECT
			Rows.n.value('ID[1]', 'int')
			,Rows.n.value('F1[1]', 'varchar(20)')
			,Rows.n.value('F2[1]', 'varchar(20)') 
			,Rows.n.value('F3[1]', 'varchar(20)') 
			,Rows.n.value('F4[1]', 'varchar(20)') 
			,Rows.n.value('F5[1]', 'varchar(20)') 
			,Rows.n.value('F6[1]', 'varchar(20)') 
			,Rows.n.value('F7[1]', 'varchar(20)') 
			,Rows.n.value('F8[1]', 'varchar(20)') 
			,Rows.n.value('F9[1]', 'varchar(20)') 
			,Rows.n.value('F10[1]', 'varchar(20)') 
			,Rows.n.value('F11[1]', 'varchar(20)') 
			,Rows.n.value('F12[1]', 'varchar(20)') 
			,Rows.n.value('F13[1]', 'varchar(20)') 
			,Rows.n.value('F14[1]', 'varchar(20)') 
			,Rows.n.value('F15[1]', 'varchar(20)') 
			,Rows.n.value('F16[1]', 'varchar(20)') 
			,Rows.n.value('F17[1]', 'varchar(20)') 
			,Rows.n.value('F18[1]', 'varchar(20)') 
			,Rows.n.value('F19[1]', 'varchar(20)') 
			,Rows.n.value('F20[1]', 'varchar(20)') 
		FROM 
			@Data.nodes('//Recs/R') Rows(n)
	commit
end
go











































if exists(
	select * 
	from sys.procedures p join sys.schemas s on p.schema_id = s.schema_id
	where s.name = 'dbo' and p.name = 'InsertDataRecordsAttrXml'
)
	drop proc dbo.InsertDataRecordsAttrXml
go

create proc dbo.InsertDataRecordsAttrXml
(
	@Data xml
)
as
begin
	set xact_abort on
	set transaction isolation level read committed
	set nocount on
	
	begin tran
		insert into dbo.DataRecords(ID,Field1,Field2,Field3,Field4,Field5,
			Field6,Field7,Field8,Field9,Field10,Field11,Field12,Field13,
			Field14,Field15,Field16,Field17,Field18,Field19,Field20)
		SELECT
			Rows.n.value('@ID[1]', 'int')
			,Rows.n.value('@F1[1]', 'varchar(20)')
			,Rows.n.value('@F2[1]', 'varchar(20)') 
			,Rows.n.value('@F3[1]', 'varchar(20)') 
			,Rows.n.value('@F4[1]', 'varchar(20)') 
			,Rows.n.value('@F5[1]', 'varchar(20)') 
			,Rows.n.value('@F6[1]', 'varchar(20)') 
			,Rows.n.value('@F7[1]', 'varchar(20)') 
			,Rows.n.value('@F8[1]', 'varchar(20)') 
			,Rows.n.value('@F9[1]', 'varchar(20)') 
			,Rows.n.value('@F10[1]', 'varchar(20)') 
			,Rows.n.value('@F11[1]', 'varchar(20)') 
			,Rows.n.value('@F12[1]', 'varchar(20)') 
			,Rows.n.value('@F13[1]', 'varchar(20)') 
			,Rows.n.value('@F14[1]', 'varchar(20)') 
			,Rows.n.value('@F15[1]', 'varchar(20)') 
			,Rows.n.value('@F16[1]', 'varchar(20)') 
			,Rows.n.value('@F17[1]', 'varchar(20)') 
			,Rows.n.value('@F18[1]', 'varchar(20)') 
			,Rows.n.value('@F19[1]', 'varchar(20)') 
			,Rows.n.value('@F20[1]', 'varchar(20)') 
		FROM 
			@Data.nodes('//Recs/R') Rows(n)
	commit
end
go














































if exists(
	select * 
	from sys.procedures p join sys.schemas s on p.schema_id = s.schema_id
	where s.name = 'dbo' and p.name = 'InsertDataRecordsOpenXML'
)
	drop proc dbo.InsertDataRecordsOpenXML
go

create proc dbo.InsertDataRecordsOpenXML
(
	@Data xml
)
as
begin
	set xact_abort on
	set transaction isolation level read committed
	set nocount on

	declare
		@Result int
		,@Handle int

	exec @Result = sp_xml_preparedocument @Handle output, @Data
	if (@Result <> 0)
	begin
		raiserror('Cannot get xml handle',17,1);
		return
	end
	
	begin tran
		insert into dbo.DataRecords(ID,Field1,Field2,Field3,Field4,Field5,
			Field6,Field7,Field8,Field9,Field10,Field11,Field12,Field13,
			Field14,Field15,Field16,Field17,Field18,Field19,Field20)
		SELECT
			ID, F1, F2, F3, F4, F5, F6, F7, F8, F9, F10,
			F11, F12, F13, F14, F15, F16, F17, F18, F19, F20
		from 
			OPENXML (@Handle, '/Recs/R',1)
		with
			(ID int, F1 varchar(20), F2 varchar(20), F3 varchar(20), 
			F4 varchar(20), F5 varchar(20), F6 varchar(20), F7 varchar(20), 
			F8 varchar(20), F9 varchar(20), F10 varchar(20), F11 varchar(20), 
			F12 varchar(20), F13 varchar(20), F14 varchar(20), F15 varchar(20), 
			F16 varchar(20), F17 varchar(20), F18 varchar(20), F19 varchar(20), 
			F20 varchar(20))
	commit
	exec sp_xml_removedocument @Handle	
end
go
















































if exists(
	select * 
	from sys.procedures p join sys.schemas s on p.schema_id = s.schema_id
	where s.name = 'dbo' and p.name = 'InsertDataRecordsAttrXml2'
)
	drop proc dbo.InsertDataRecordsAttrXml2
go

create proc dbo.InsertDataRecordsAttrXml2
(
	@Data xml
)
as
begin
	set xact_abort on
	set transaction isolation level read committed
	set nocount on
	
	declare
		@Temp table 
		(
			ID int not null,
			Field1 varchar(20) not null,
			Field2 varchar(20) not null,	
			Field3 varchar(20) not null,	
			Field4 varchar(20) not null,	
			Field5 varchar(20) not null,
			Field6 varchar(20) not null,	
			Field7 varchar(20) not null,	
			Field8 varchar(20) not null,	
			Field9 varchar(20) not null,
			Field10 varchar(20) not null,	
			Field11 varchar(20) not null,	
			Field12 varchar(20) not null,	
			Field13 varchar(20) not null,
			Field14 varchar(20) not null,	
			Field15 varchar(20) not null,	
			Field16 varchar(20) not null,	
			Field17 varchar(20) not null,
			Field18 varchar(20) not null,	
			Field19 varchar(20) not null,	
			Field20 varchar(20) not null
		)			

	insert into @Temp(ID,Field1,Field2,Field3,Field4,Field5,
			Field6,Field7,Field8,Field9,Field10,Field11,Field12,Field13,
			Field14,Field15,Field16,Field17,Field18,Field19,Field20)
		SELECT
			Rows.n.value('@ID[1]', 'int')
			,Rows.n.value('@F1[1]', 'varchar(20)')
			,Rows.n.value('@F2[1]', 'varchar(20)') 
			,Rows.n.value('@F3[1]', 'varchar(20)') 
			,Rows.n.value('@F4[1]', 'varchar(20)') 
			,Rows.n.value('@F5[1]', 'varchar(20)') 
			,Rows.n.value('@F6[1]', 'varchar(20)') 
			,Rows.n.value('@F7[1]', 'varchar(20)') 
			,Rows.n.value('@F8[1]', 'varchar(20)') 
			,Rows.n.value('@F9[1]', 'varchar(20)') 
			,Rows.n.value('@F10[1]', 'varchar(20)') 
			,Rows.n.value('@F11[1]', 'varchar(20)') 
			,Rows.n.value('@F12[1]', 'varchar(20)') 
			,Rows.n.value('@F13[1]', 'varchar(20)') 
			,Rows.n.value('@F14[1]', 'varchar(20)') 
			,Rows.n.value('@F15[1]', 'varchar(20)') 
			,Rows.n.value('@F16[1]', 'varchar(20)') 
			,Rows.n.value('@F17[1]', 'varchar(20)') 
			,Rows.n.value('@F18[1]', 'varchar(20)') 
			,Rows.n.value('@F19[1]', 'varchar(20)') 
			,Rows.n.value('@F20[1]', 'varchar(20)') 
		FROM 
			@Data.nodes('//Recs/R') Rows(n)
	
	begin tran
		insert into dbo.DataRecords(ID,Field1,Field2,Field3,Field4,Field5,
			Field6,Field7,Field8,Field9,Field10,Field11,Field12,Field13,
			Field14,Field15,Field16,Field17,Field18,Field19,Field20)
		SELECT
			ID,Field1,Field2,Field3,Field4,Field5,
			Field6,Field7,Field8,Field9,Field10,Field11,Field12,Field13,
			Field14,Field15,Field16,Field17,Field18,Field19,Field20
		from @Temp
	commit
end
go
