/**********************************************************************
SQL Saturday #62 (January 15th, 2010. Tampa, FL)

Dmitri Korotkevitch: "Refactoring for performance"

Supporting script
**********************************************************************/


/*
dbcc freeproccache
go
*/

SELECT TOP 50 
	SUBSTRING(qt.TEXT, (qs.statement_start_offset/2)+1,
		((
			CASE qs.statement_end_offset
				WHEN -1 THEN DATALENGTH(qt.TEXT)
				ELSE qs.statement_end_offset
			END - qs.statement_start_offset)/2)+1),
	qs.execution_count,
	(qs.total_logical_reads + qs.total_logical_writes) / qs.execution_count as [Avg IO],
	qs.total_logical_reads, qs.last_logical_reads,
	qs.total_logical_writes, qs.last_logical_writes,
	qs.total_worker_time,
	qs.last_worker_time,
	qs.total_elapsed_time/1000 total_elapsed_time_in_ms,
	qs.last_elapsed_time/1000 last_elapsed_time_in_ms,
	qs.last_execution_time,
	qp.query_plan
FROM 
	sys.dm_exec_query_stats qs
		cross APPLY sys.dm_exec_sql_text(qs.sql_handle) qt
		cross APPLY sys.dm_exec_query_plan(qs.plan_handle) qp
ORDER BY 
	qs.total_logical_reads DESC
go


